/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.enums.EnumFormtype;
import de.ship.db.enums.EnumInputlayout;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TInputReference.TInputReferencePath;
import de.ship.db.tables.records.TInputWebformRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputWebform extends TableImpl<TInputWebformRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_webform</code>
     */
    public static final TInputWebform T_INPUT_WEBFORM = new TInputWebform();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputWebformRecord> getRecordType() {
        return TInputWebformRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_webform.lastchange</code>.
     */
    public final TableField<TInputWebformRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_input_webform.fk_form</code>. foreign key to
     * key_element of referenced form
     */
    public final TableField<TInputWebformRecord, Integer> FK_FORM = createField(DSL.name("fk_form"), SQLDataType.INTEGER.nullable(false), this, "foreign key to key_element of referenced form");

    /**
     * The column <code>common_dd.t_input_webform.inputlayout</code>. topdown,
     * xypos, ...
     */
    public final TableField<TInputWebformRecord, EnumInputlayout> INPUTLAYOUT = createField(DSL.name("inputlayout"), SQLDataType.VARCHAR.nullable(false).asEnumDataType(EnumInputlayout.class), this, "topdown, xypos, ...");

    /**
     * The column <code>common_dd.t_input_webform.form_order</code>. absolute
     * order of form
     */
    public final TableField<TInputWebformRecord, Integer> FORM_ORDER = createField(DSL.name("form_order"), SQLDataType.INTEGER.nullable(false), this, "absolute order of form");

    /**
     * The column <code>common_dd.t_input_webform.fk_study_generation</code>.
     * foreign key to key_element of referenced study
     */
    public final TableField<TInputWebformRecord, Integer> FK_STUDY_GENERATION = createField(DSL.name("fk_study_generation"), SQLDataType.INTEGER.nullable(false), this, "foreign key to key_element of referenced study");

    /**
     * The column <code>common_dd.t_input_webform.ignore_closed_visits</code>.
     * allow form filling on closed visits
     */
    public final TableField<TInputWebformRecord, Boolean> IGNORE_CLOSED_VISITS = createField(DSL.name("ignore_closed_visits"), SQLDataType.BOOLEAN.defaultValue(DSL.field(DSL.raw("false"), SQLDataType.BOOLEAN)), this, "allow form filling on closed visits");

    /**
     * The column <code>common_dd.t_input_webform.min_obs</code>. null
     * (default): no minimum number of observations for form needed, n&gt;0: n
     * number of observations needed to be valid
     */
    public final TableField<TInputWebformRecord, Integer> MIN_OBS = createField(DSL.name("min_obs"), SQLDataType.INTEGER, this, "null (default): no minimum number of observations for form needed, n>0: n number of observations needed to be valid");

    /**
     * The column <code>common_dd.t_input_webform.max_obs</code>. null
     * (default): no maximum number of observations for form, n&gt;0: maximumn
     * of n observations  for this form allowed
     */
    public final TableField<TInputWebformRecord, Integer> MAX_OBS = createField(DSL.name("max_obs"), SQLDataType.INTEGER, this, "null (default): no maximum number of observations for form, n>0: maximumn of n observations  for this form allowed");

    /**
     * The column <code>common_dd.t_input_webform.user_owns</code>. false: any
     * user can edit the form of the observation created by another user, true:
     * only the creator of the form observation may edit it
     */
    public final TableField<TInputWebformRecord, Boolean> USER_OWNS = createField(DSL.name("user_owns"), SQLDataType.BOOLEAN.defaultValue(DSL.field(DSL.raw("false"), SQLDataType.BOOLEAN)), this, "false: any user can edit the form of the observation created by another user, true: only the creator of the form observation may edit it");

    /**
     * The column <code>common_dd.t_input_webform.fk_reference</code>. reference
     */
    public final TableField<TInputWebformRecord, String> FK_REFERENCE = createField(DSL.name("fk_reference"), SQLDataType.CLOB, this, "reference");

    /**
     * The column <code>common_dd.t_input_webform.form_type</code>.
     */
    public final TableField<TInputWebformRecord, EnumFormtype> FORM_TYPE = createField(DSL.name("form_type"), SQLDataType.VARCHAR.nullable(false).defaultValue(DSL.field(DSL.raw("'standard'::common_dd.enum_formtype"), SQLDataType.VARCHAR)).asEnumDataType(EnumFormtype.class), this, "");

    private TInputWebform(Name alias, Table<TInputWebformRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputWebform(Name alias, Table<TInputWebformRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_webform</code> table reference
     */
    public TInputWebform(String alias) {
        this(DSL.name(alias), T_INPUT_WEBFORM);
    }

    /**
     * Create an aliased <code>common_dd.t_input_webform</code> table reference
     */
    public TInputWebform(Name alias) {
        this(alias, T_INPUT_WEBFORM);
    }

    /**
     * Create a <code>common_dd.t_input_webform</code> table reference
     */
    public TInputWebform() {
        this(DSL.name("t_input_webform"), null);
    }

    public <O extends Record> TInputWebform(Table<O> path, ForeignKey<O, TInputWebformRecord> childPath, InverseForeignKey<O, TInputWebformRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_WEBFORM);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputWebformPath extends TInputWebform implements Path<TInputWebformRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputWebformPath(Table<O> path, ForeignKey<O, TInputWebformRecord> childPath, InverseForeignKey<O, TInputWebformRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputWebformPath(Name alias, Table<TInputWebformRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputWebformPath as(String alias) {
            return new TInputWebformPath(DSL.name(alias), this);
        }

        @Override
        public TInputWebformPath as(Name alias) {
            return new TInputWebformPath(alias, this);
        }

        @Override
        public TInputWebformPath as(Table<?> alias) {
            return new TInputWebformPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public UniqueKey<TInputWebformRecord> getPrimaryKey() {
        return Keys.PK_INPUT_WEBFORM;
    }

    @Override
    public List<UniqueKey<TInputWebformRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_INPUT_WEBFORM);
    }

    @Override
    public List<ForeignKey<TInputWebformRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_INPUT_WEBFORM__FK_WEBFORM_FORM, Keys.T_INPUT_WEBFORM__FK_WEBFORM_STUDYGEN, Keys.T_INPUT_WEBFORM__FK_WEBFORM_REFERENCE);
    }

    private transient TCoreElementHierarchyPath _fkWebformForm;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table, via the
     * <code>fk_webform_form</code> key.
     */
    public TCoreElementHierarchyPath fkWebformForm() {
        if (_fkWebformForm == null)
            _fkWebformForm = new TCoreElementHierarchyPath(this, Keys.T_INPUT_WEBFORM__FK_WEBFORM_FORM, null);

        return _fkWebformForm;
    }

    private transient TCoreElementHierarchyPath _fkWebformStudygen;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table, via the
     * <code>fk_webform_studygen</code> key.
     */
    public TCoreElementHierarchyPath fkWebformStudygen() {
        if (_fkWebformStudygen == null)
            _fkWebformStudygen = new TCoreElementHierarchyPath(this, Keys.T_INPUT_WEBFORM__FK_WEBFORM_STUDYGEN, null);

        return _fkWebformStudygen;
    }

    private transient TInputReferencePath _tInputReference;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_input_reference</code> table.
     */
    public TInputReferencePath tInputReference() {
        if (_tInputReference == null)
            _tInputReference = new TInputReferencePath(this, Keys.T_INPUT_WEBFORM__FK_WEBFORM_REFERENCE, null);

        return _tInputReference;
    }

    @Override
    public TInputWebform as(String alias) {
        return new TInputWebform(DSL.name(alias), this);
    }

    @Override
    public TInputWebform as(Name alias) {
        return new TInputWebform(alias, this);
    }

    @Override
    public TInputWebform as(Table<?> alias) {
        return new TInputWebform(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputWebform rename(String name) {
        return new TInputWebform(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputWebform rename(Name name) {
        return new TInputWebform(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputWebform rename(Table<?> name) {
        return new TInputWebform(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputWebform where(Condition condition) {
        return new TInputWebform(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputWebform where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputWebform where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputWebform where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputWebform where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputWebform where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputWebform where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputWebform where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputWebform whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputWebform whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
